<?php

header('Access-Control-Allow-Origin: *');
header('Content-Type: application/json');


include ('../../backend/connection.php');


$contentType = isset($_SERVER["CONTENT_TYPE"]) ? trim($_SERVER["CONTENT_TYPE"]) : '';

if ($contentType === "application/json") {
    // Receive the RAW post data.
    $content = trim(file_get_contents("php://input"));

    // Attempt to decode the incoming RAW post data from JSON.
    $decoded = json_decode($content, true);

    // If json_decode failed, the JSON is invalid.
    if (!is_array($decoded)) {
        // Invalid JSON format
        $response = array (
            'status_code' => 400,
            'msg' => 'Invalid JSON format'
        );
        echo json_encode($response);
        exit;
    } else {
        // Valid JSON format
        $api_key = $decoded['api_key'];
        $campaign_name = $decoded['campaign_name'];
        $client_id = $decoded['user_id'];
        $send_id_value = $decoded['sender_id'];
        $message = $decoded['message'];
        $recipient_contact_no = $decoded['recipient_contacts'];
    }
} else {
    // Handle form-data input
    $api_key = $_REQUEST['api_key'];
    $campaign_name        = $_REQUEST['campaign_name'];
    $client_id = $_REQUEST['user_id'];
    $send_id_value = $_REQUEST['sender_id'];
    $message = $_REQUEST['message'];
    $recipient_contact_no = $_REQUEST['recipient_contacts'];
}

// $api_key              = $_REQUEST['api_key'];
// $campaign_name        = $_REQUEST['campaign_name'];
// $client_id            = $_REQUEST['user_id'];
// $send_id_value        = $_REQUEST['sender_id'];
// $message              = $_REQUEST['message'];
// $recipient_contact_no = $_REQUEST['recipient_contacts'];


function insertLog($addBy, $log, $module){
    
    include '../../backend/connection.php';
  
    $sql_log_insert = "INSERT INTO `user_log` (`add_by`, `module`, `message`) VALUES (?, ?, ?)";
    $stmt = $conn->prepare($sql_log_insert);

    if ($stmt) {
        $stmt->bind_param("sss", $addBy, $module, $log);
        $stmt->execute();
        $stmt->close();
        $conn->close();
        return true;
    } else {
        return false;
    }
}


    function getGatewayid($client_id,$sender_id){
    
    include '../../backend/connection.php';
    
    $query1 = "SELECT `defaultGatway`FROM `sender_details` WHERE (`client_id` = '$client_id' OR `client_id` = '0')  AND `sender_id`= '$sender_id'";
    $stmt1 = $conn->prepare($query1);
    $stmt1->execute();
    $result1 = $stmt1->get_result();
    
     if ($result1->num_rows > 0) {
         
         $row1 = $result1->fetch_assoc();
         $gate_id1 = $row1['defaultGatway'];
         
        $query2 = "SELECT `status`,`id` FROM `gateway` WHERE `id` = '$gate_id1' AND `status`='active'";
        $stmt2 = $conn->prepare($query2);
        $stmt2->execute();
        $result2 = $stmt2->get_result();
        
        if ($result2->num_rows > 0) {
            
            $row2 = $result2->fetch_assoc();
            
           $gate_id = $row2['id'];
           $gate_st = $row2['status'];
            
        }
         
     }
   return  $gate_id;
    
}


function generateRandomToken($length = 4) {
    $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $token = '';
    $max = strlen($characters) - 1;
    for ($i = 0; $i < $length; $i++) {
        $token .= $characters[random_int(0, $max)];
    }
    return $token;
   }

function CharacterTypemessage($type,$text){
    
 
    
    if($type === 'ASCII'){

            // $characterCount = strlen($text);
            $characterCount = mb_strlen($text, 'UTF-8');
            if($characterCount <= 160){
    
              $total_pageCount=1;
          
             } else if($characterCount<=306) {         
           $total_pageCount=2;
            } else if($characterCount<=459) {       
           $total_pageCount=3;
            } else if($characterCount<=602) {       
           $total_pageCount=4;
            } else {
           $total_pageCount='maxcount';
    
        }
    
    }else{
            // $characterCount = strlen($text);
            $characterCount = mb_strlen($text, 'UTF-8');
            if($characterCount<=70){
          
                $total_pageCount=1;
                
               } else if($characterCount<=134) {
                
                 $total_pageCount=2;
              }  else if($characterCount<=201) {
                
                 $total_pageCount=3;
              }  else if($characterCount<=268) {
                
                 $total_pageCount=4;
              } 
              else {
                 $total_pageCount='noUnicodeLimit';
          
              }
    }
return $total_pageCount;

}


 
  $arraySuccess      = array();
  $arraySuccessVal   = array();
  $contacts          = array();
  
  $arrayUnsuccess    = array();
  $arrayUnsuccessVal = array();
  $id_api = 1;
  
    $query_apis = "SELECT `api_mod` FROM `system_setting` WHERE `id` = ?";
    $stmt_apis = $conn->prepare($query_apis);
    $stmt_apis->bind_param('i', $id_api);
    $stmt_apis->execute();
    $result_apis = $stmt_apis->get_result();
    $row_group = $result_apis->fetch_assoc();
    $api_mode= $row_group['api_mod'];
   
    if($api_mode == 0){
        
    $queryc = "SELECT `api_status` FROM `clients` WHERE `c_id` = ? AND `status`= 1 AND `verification_status`=1";
    $stmtc = $conn->prepare($queryc);
    $stmtc->bind_param('i', $client_id);
    $stmtc->execute();
    $resultc = $stmtc->get_result();
    if ($resultc->num_rows > 0) {
        $rowc = $resultc->fetch_assoc();
       $apistatus   = $rowc['api_status'];
        
        if($apistatus === 1){
            $query = "SELECT `status`,`api_status`,`adminStatus`,`type`,`promo_per_msg`,`trans_per_msg` FROM `sender_details` WHERE `client_id` = ? AND `sender_id`= ? AND `status`='Active' AND `adminStatus`='approved'";
            $stmt = $conn->prepare($query);
            $stmt->bind_param('is', $client_id,$send_id_value);
            $stmt->execute();
            $result = $stmt->get_result();
    
                      if ($result->num_rows > 0) {
                          
                         $row = $result->fetch_assoc();
                         
                         $apistatuss  = $row['api_status'];
                         $adminStatus = $row['adminStatus'];
                         $status      = $row['status'];
                         $stype       = $row['type'];
                         $promo_cost  = $row['promo_per_msg'];
                         $trans_cost  = $row['trans_per_msg'];
                         
                        
                         
                                  if($apistatuss === 1){
                                      
                                    $query = "SELECT * FROM `clients` WHERE `c_id` = ? AND `status`= 1 AND `verification_status`=1";
                                    $stmt = $conn->prepare($query);
                                    $stmt->bind_param('i', $client_id);
                                    $stmt->execute();
                                    $result = $stmt->get_result();
                                    
                                        if ($result->num_rows > 0) {
                                                            
                                             $row = $result->fetch_assoc();
                                             
                                             $api_key_client = $row['api_key'];
                                             $clientBalance =  $row['current_balance'];
                                             
                                             
                                             if($api_key == $api_key_client){
                                                 
                                                 if($recipient_contact_no){
                                                     
                                                     $myArray = explode(',', $recipient_contact_no);
                                                     $contact_count = count($myArray);
                                                     
                                                     if($contact_count > 0){
                                                         
                                                         $sucessCount = array();
                                                         
                                                          for ($x = 0; $x < $contact_count; $x++) {
                                                              
                                                              $contactNo = $myArray[$x];
                                                              
                                                              if (preg_match('/[^\d\+]/', $contactNo)) {
                                                                   
                                                                    //Contact Number is Invalid 
                                                                   
                                                                    $arrayUnsuccessVal = array();
                                                        
                                                                    $arrayUnsuccessVal['number'] = $contactNo;
                                                                    $arrayUnsuccessVal['status'] = 203;
                                                                                                                                        
                                                                    array_push($arrayUnsuccess, $arrayUnsuccessVal);
                              
                                                                }else{
                                                                    
                                                                     $contactNumLen =  strlen($contactNo);
                                                                     
                                                                      if($contactNumLen === 11){
                                                                                                                             
                                                                          $messageN = str_replace(array("\r\n", "\r", "\n"),'\\n', $message);
                                                                          $charactorType = mb_detect_encoding($messageN, 'ASCII', true);
                                                                          $totalPages =  CharacterTypemessage($charactorType,$messageN);
                                                                          $characterCountn = mb_strlen($messageN, 'UTF-8');
                                                                          
                                                                        //   $smscostper = $totalPages*$characterCountn;
                                                                          
                                                                          if($charactorType ==='ASCII'){
                                                                              $encodingtype = 'ASCII';
                                                                          }else{
                                                                              
                                                                              $encodingtype = 'UNICODE';
                                                                              
                                                                          }
                                                                          
                                                                          if($totalPages !=='noUnicodeLimit' || $totalPages !=='maxcount'){
                                                                              
                                                                                  if($stype ==='promotional'){
                                                                                      
                                                                                      $price_per_page = $promo_cost;
                                                                                      
                                                                                  }else if($stype ==='transactional'){
                                                                                      
                                                                                      $price_per_page = $trans_cost;
                                                                                      
                                                                                  }
                                                                                  
                                                                                  $totalsmsCost = $totalPages * $price_per_page;
                                                                                   
                                                                                  array_push($sucessCount,$totalsmsCost);
                                                                                  array_push($contacts,$contactNo);
                                                                                   
                                                                                   
                                                                              
                                                                              
                                                                          }else{
                                                                              
                                                                              //Sending the Messsage is Unsuccessfull
                                                                                $response = array (
                                                                              'result' => 'unsuccess',
                                                                                'status' => 209
                                                                                 );
                                                                              
                                                                              
                                                                          }
                                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                      }else{
                                                                           
                                                                            $arrayUnsuccessVal = array();
                                                                
                                                                            $arrayUnsuccessVal['number'] = $contactNo;
                                                                            $arrayUnsuccessVal['status'] = 205;
                                                                            
                                                                            array_push($arrayUnsuccess, $arrayUnsuccessVal);
                                                                                   
                                                                      }
                                                                    
                                                                }
                                                              
                                                          }
                                                          
                                                        //   $smspercost =  $totalPages * $price_per_page;
                                                          
                                                          $totsmscost = count($sucessCount);
                                                          $smscampfee = 0;
                                                          
                                                          if($totsmscost > 0 ){
                                                              for ($j = 0; $j < $totsmscost; $j++) {
                                                                  $smsfee = $sucessCount[$j];
                                                                  
                                                                  $smscampfee += $smsfee;
                                                                  
                                                                  
                                                              }
                                                              
                                                              if($smscampfee < $clientBalance){
                                                                  
                                                                  $totsuccesscontact = count($contacts);
                                                                  
                                                                  if($totsuccesscontact>0){
                                                                      
                                                                       $current_balance =  $clientBalance - $smscampfee;
                                                                       $smspercost = $smscampfee / $totsuccesscontact;
                                                                     
                                                                        $sql_update_ind  = "UPDATE `clients` SET `current_balance`=? WHERE `c_id` = ? ";
                                                                        $res_update_inv  = $conn->prepare($sql_update_ind);
                                                                        $res_update_inv->bind_param('si', $current_balance, $client_id);
                                                                        $res_update_inv->execute();
                                                                                    
                                                                                    if($res_update_inv){
                                                                                        
                                                                                          $datequick = date("Y-m-d H:i:s");
                                                                                          $campaign_statusn = 'sent'; 
                                                                                          $campaignname = ' API- '.$campaign_name;
                                                                                          $sql_camp_insert       = "INSERT INTO `compaign_details` (`compaign_name`,`message`,`sender_id`,`send_by_contacts`,`client_id`,`compaign_date`,`total_cost`,`per_sms_cost`,`c_type`,`c_count`,`pagecount`,`rate`,`compaign_status`) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?)";
                                                                                          $result_camp_insert    = $conn->prepare($sql_camp_insert);
                                                                                          $result_camp_insert->execute([$campaignname, $messageN, $send_id_value,$totsuccesscontact,$client_id,$datequick,$smscampfee,$smspercost,$encodingtype,$characterCountn,$totalPages,$price_per_page,$campaign_statusn]);
                                                                                          $last_IdCamp          =  mysqli_insert_id($conn);  
                                                                                          
                                                                                            for ($z = 0; $z < $totsuccesscontact; $z++) {
                                                                          
                                                                                                  $mobile = $contacts[$z];
                                                                                                  
                                                                                                  $gateway_id =  getGatewayid($client_id,$send_id_value);
                                                                                        $bulkid = generateRandomToken(); 
                                                                       
                                                                                        $data = array(
                                                                                            'senderID' => $send_id_value,
                                                                                            'recipient_contact_no' => $mobile,
                                                                                            'client_id' => $client_id,
                                                                                            'message'=>$messageN,
                                                                                            'gateway_id'=>$gateway_id,
                                                                                            'secret_key'=>'oZone@2024*API'
                                                                                        );
                                                                                        
                                                                                        // Convert the data array to JSON format
                                                                                        $data_json = json_encode($data);
                                                                                        
                                                                                        // Initialize cURL
                                                                                        $ch = curl_init('https://backendapi.ozonesender.com/backend/route.php');
                                                                                        
                                                                                        // Set the options for the POST request
                                                                                        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                                                                                        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));
                                                                                        curl_setopt($ch, CURLOPT_POST, true);
                                                                                        curl_setopt($ch, CURLOPT_POSTFIELDS, $data_json);
                                                                                        
                                                                                        // Execute the POST request
                                                                                        $response1 = curl_exec($ch);
                                                                                        
                                                                                        // Check for errors
                                                                                        if($response1 === FALSE){
                                                                                            die(curl_error($ch));
                                                                                        }
                                                                                        
                                                                                        
                                                                                      
                                                                                        
                                                                                        // Close the cURL session
                                                                                        curl_close($ch);
                                                                                        
                                                                                        $sms_result_array = json_decode($response1, true);
                                                                                        
                                                                                        if($gateway_id == 1){
                                                                                            
                                                                                            $status_code = $sms_result_array['status_code'];
                                                                                            $msg_id      = $sms_result_array['msg_id'];
                                                                                            
                                                                                            if($status_code == 204){
                                                                                             
                                                                                                $gateway_status = 2;
                                                                                            }else{
                                                                                                
                                                                                                 $gateway_status = 3;
                                                                                            }
                                                                                                                         
                                                                                          
                                                                                            
                                                                                            
                                                                                        }else if($gateway_id == 2){
                                                                                            
                                                                                            $status = $sms_result_array['status'];
                                                                                            $result = $sms_result_array['result'];
                                                                                            $msg_id = $sms_result_array['msg_id'];
                                                                                            
                                                                                             if ($status == 'success') {
                                                                                                 $gateway_status = 2;
                                                                                                 
                                                                                             }else{
                                                                                                  $gateway_status = 3;
                                                                                             }
                                                                                            
                                                                                        }else if($gateway_id == 3){
                                                                                            
                                                                                            $sms_ststus = $sms_result_array["status"];
                                                                                            $sms_comment =$sms_result_array["comment"];
                                                                                            $msg_id =$sms_result_array["data"]["campaignId"];
                                                                                            $sms_gateway_cost = $sms_result_array["data"]["campaignCost"];
                                                                                            $sms_Gateway_error= $sms_result_array["data"]["errCode"];
                                                                                            
                                                                                             if ($sms_ststus == 'success') {
                                                                                                 $gateway_status = 2;
                                                                                                 
                                                                                             }else{
                                                                                                  $gateway_status = 3;
                                                                                             }
                                                                                            
                                                                                        }else if($gateway_id == 4){
                                                                                            
                                                                                             $msg_id = $sms_result_array["serverRef"];
                                                                                             $gateway_status = 2;
                                                                                            
                                                                                            
                                                                                        }
                                                                                                   
                                                                                                   
                                                                                                    $type ='apibulk';
                                                                                              
                                                                                                    $dateind = date("Y-m-d H:i:s");
                                                                                              
                                                                                                    $scheduleDateandtimen='no';
                                                                                                   
                                                                                                    $sql_log_insert       = "INSERT INTO `logs` (`compaign_id`,`sender_id`,`message`,`type`,`schedule`,`send_to`,`client_id`,`create_date`,`send_date`,`serverResponse`,`bulkid`,`g_deliveryStatus`,`g_responce_id`,`page_count`,`total_cost`,`c_count`,`c_type`,`rate`) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
                                                                                                    $result_log_insert    = $conn->prepare($sql_log_insert);
                                                                                                    $result_log_insert->execute([$last_IdCamp,$send_id_value, $messageN, $type,$scheduleDateandtimen,$mobile,$client_id,$dateind,$dateind,$response1,$bulkid,$gateway_status,$msg_id,$totalPages,$smspercost,$characterCountn,$encodingtype,$price_per_page]); 
                                                                                                    
                                                                                                    $last_Id          =  mysqli_insert_id($conn);
                                                                                                    
                                                                                                    if ($result_log_insert){
                                                                                                        
                                                                                                          $arraySuccessVal      = array();
                                                                                                          $arraySuccessVal['number']   = $mobile;
                                                                                                          $arraySuccessVal['msgId']    = $last_Id;
                                                                                                          
                                                                                                          array_push($arraySuccess, $arraySuccessVal);
                                                        
                                                                                                    }else{
                                                                                                        
                                                                                                        //Sending the Messsage is Unsuccessfull
                                                                                                        $response = array (
                                                                                                      'result' => 'unsuccess',
                                                                                                        'status' => 209
                                                                                                         );
                                                                                                        
                                                                                                    }
                                                                                                  
                                                                                                  
                                                                                              }
                                                                                        
                                                                                       
                                                                                        $typemessage='apiBulk';
                                                                                         $datetim = date("Y-m-d H:i:s");
                                                                                        $sql_account_insert       = "INSERT INTO `account_history` (`current_balance`,`campaign_id`,`cost`,`new_balance`,`datetime`,`log`,`type`,`pages`,`c_type`,`byID`,`whose`) VALUES (?,?,?,?,?,?,?,?,?,?,?)";
                                                                                        $result_account_insert    = $conn->prepare($sql_account_insert);
                                                                                        $result_account_insert->execute([$clientBalance,$last_IdCamp, $smscampfee, $current_balance,$datetim,$last_Id,$typemessage,$totalPages,$encodingtype,$client_id,$client_id]); 
                                                                                        
                                                                                                                                
                                                                                        
                                                                                    $log = 'API Bulk sms send by Client id : '.$client_id.' to  using  with a '.$smscampfee.'LKR cost'.' (Sms  Log Id - '.$last_Id.' )';
                                                                                    $module_inv     = "SMS Manager";
                                                                                    insertLog($client_id, $log, $module_inv);
                                                                                        
                                                                                          $response = array(
                                                                                            "success"    => array($arraySuccess),   
                                                                                            "unsuccess"  => array($arrayUnsuccess),
                                                                                        );
                                                                                                                                        
                                                                                        
                                                                                        
                                                                                    }
                                                                      
                                                                  
                                                                      
                                                                  }
                                                                  
                                                                  
                                                                       
                                                                  
                                                                  
                                                                  
                                                                  
                                                              }else{
                                                                  
                                                                     //Account Balance is Insufficient
                                                            
                                                                    $response = array (
                                                                  'result' => 'unsuccess',
                                                                    'status' => 208
                                                                     );
                                                              
                                                          }
                                                                  
                                                              
                                                              
                                                              
                                                              
                                                          }else{
                                                              
                                                          // No Contact Numbers
                                                            
                                                            $response = array (
                                                          'result' => 'unsuccess',
                                                            'status' => 207
                                                             );
                                                              
                                                          }
                                                          
                                                          
                                                         
                                                         
                                                         
                                                     }else{
                                                         
                                                            // No Contact Numbers
                                                            
                                                            $response = array (
                                                          'result' => 'unsuccess',
                                                            'status' => 207
                                                             );
                                                         
                                                     }
                   
                                                 }else{
                                                     
                                                    // No Contact Numbers
                                                    
                                                    $response = array (
                                                  'result' => 'unsuccess',
                                                    'status' => 207
                                                     );
                
                                                 }
                                                 
                                             }else{
                                                                      
                                                 // invalid api key
                                                 $response = array (
                                                  'result' => 'unsuccess',
                                                    'status' => 202
                                              );
                                                 
                                             }
                                             
                                        }else{
                                    
                                            //client is suspended
                                            $response = array (
                                                  'result' => 'unsuccess',
                                                    'status' => 210
                                              );
                                                
                                   
                                         
                                        }
                                      
                                      
                                      
                                  }else{
                                      
                                             //API Status is Inactive
                                              
                                                $response = array (
                                                  'result' => 'unsuccesss',
                                                    'status' => 201
                                              );
                                  }
                          
                          
                      }else{
                        
                        //no sender id or Inactive sender id or not Approved senderID
                        
                              $response = array (
                                  'result' => 'unsuccess',
                                    'status' => 211
                              );
                        
                   
                        
                    }
            
        }else{
            
            //API Status is Inactive
            $response = array (
                  'result' => 'unsuccess',
                    'status' => 201
              );
            
        }
        
    }


    }else{
        
        $response = array (
                  'result' => 'unsuccess',
                    'status' => 214 );
        
    }




 echo json_encode($response, JSON_PRETTY_PRINT);



?>