<?php

header('Access-Control-Allow-Origin: *');
header('Content-Type: application/json');


include ('../../backend/connection.php');

$contentType = isset($_SERVER["CONTENT_TYPE"]) ? trim($_SERVER["CONTENT_TYPE"]) : '';

if ($contentType === "application/json") {
    // Receive the RAW post data.
    $content = trim(file_get_contents("php://input"));

    // Attempt to decode the incoming RAW post data from JSON.
    $decoded = json_decode($content, true);

    // If json_decode failed, the JSON is invalid.
    if (!is_array($decoded)) {
        // Invalid JSON format
        $response = array (
            'status_code' => 400,
            'msg' => 'Invalid JSON format'
        );
        echo json_encode($response);
        exit;
    } else {
        // Valid JSON format
        $api_key = $decoded['api_key'];
        $client_id = $decoded['user_id'];
        $send_id_value = $decoded['sender_id'];
        $message = $decoded['message'];
        $recipient_contact_no = $decoded['recipient_contact_no'];
    }
} else {
    // Handle form-data input
    $api_key = $_REQUEST['api_key'];
    $client_id = $_REQUEST['user_id'];
    $send_id_value = $_REQUEST['sender_id'];
    $message = $_REQUEST['message'];
    $recipient_contact_no = $_REQUEST['recipient_contact_no'];
}


function insertLog($addBy, $log, $module){
    include '../../backend/connection.php';
  
    $sql_log_insert = "INSERT INTO `user_log` (`add_by`, `module`, `message`) VALUES (?, ?, ?)";
    $stmt = $conn->prepare($sql_log_insert);

    if ($stmt) {
        $stmt->bind_param("sss", $addBy, $module, $log);
        $stmt->execute();
        $stmt->close();
        $conn->close();
        return true;
    } else {
        return false;
    }
}


    function getGatewayid($client_id,$sender_id){
    
    include '../../backend/connection.php';
    
    $query1 = "SELECT `defaultGatway`FROM `sender_details` WHERE (`client_id` = '$client_id' OR `client_id` = '0')  AND `sender_id`= '$sender_id'";
    $stmt1 = $conn->prepare($query1);
    $stmt1->execute();
    $result1 = $stmt1->get_result();
    
     if ($result1->num_rows > 0) {
         
         $row1 = $result1->fetch_assoc();
         $gate_id1 = $row1['defaultGatway'];
         
        $query2 = "SELECT `status`,`id` FROM `gateway` WHERE `id` = '$gate_id1' AND `status`='active'";
        $stmt2 = $conn->prepare($query2);
        $stmt2->execute();
        $result2 = $stmt2->get_result();
        
        if ($result2->num_rows > 0) {
            
            $row2 = $result2->fetch_assoc();
            
           $gate_id = $row2['id'];
           $gate_st = $row2['status'];
            
        }
         
     }
   return  $gate_id;
    
}


function generateRandomToken($length = 4) {
    $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $token = '';
    $max = strlen($characters) - 1;
    for ($i = 0; $i < $length; $i++) {
        $token .= $characters[random_int(0, $max)];
    }
    return $token;
   }


//function to identify character type and assign page count

function CharacterTypemessage($type,$text){
    
 
    
    if($type === 'ASCII'){

            // $characterCount = strlen($text);
            $characterCount = mb_strlen($text, 'UTF-8');
            if($characterCount <= 160){
    
              $total_pageCount=1;
          
             } else if($characterCount<=306) {         
           $total_pageCount=2;
            } else if($characterCount<=459) {       
           $total_pageCount=3;
            } else if($characterCount<=602) {       
           $total_pageCount=4;
            } else {
           $total_pageCount='maxcount';
    
         }
    
    }else{
            // $characterCount = strlen($text);
            $characterCount = mb_strlen($text, 'UTF-8');
            if($characterCount<=70){
          
                $total_pageCount=1;
                
               } else if($characterCount<=134) {
                
                 $total_pageCount=2;
              }  else if($characterCount<=201) {
                
                 $total_pageCount=3;
              }  else if($characterCount<=268) {
                
                 $total_pageCount=4;
              } 
              else {
                 $total_pageCount='noUnicodeLimit';
          
              }
    }
return $total_pageCount;

}
  $id_api =1;
  $query_apis = "SELECT `api_mod` FROM `system_setting` WHERE `id` = ?";
    $stmt_apis = $conn->prepare($query_apis);
    $stmt_apis->bind_param('i', $id_api);
    $stmt_apis->execute();
    $result_apis = $stmt_apis->get_result();
    $row_group = $result_apis->fetch_assoc();
    $api_mode= $row_group['api_mod'];
   
    if($api_mode == 0){

 $queryc = "SELECT `api_status` FROM `clients` WHERE `c_id` = ? AND `status`= '1' AND `verification_status`='1'";
    $stmtc = $conn->prepare($queryc);
    $stmtc->bind_param('i', $client_id);
    $stmtc->execute();
    $resultc = $stmtc->get_result();
    if ($resultc->num_rows > 0) {
        $rowc = $resultc->fetch_assoc();
        $apistatus   = $rowc['api_status'];
        
        if($apistatus === 1){
            
                $query = "SELECT `status`,`api_status`,`adminStatus`,`type`,`promo_per_msg`,`trans_per_msg` FROM `sender_details` WHERE `client_id` = ? AND `sender_id`= ? AND `status`='Active' AND `adminStatus`='approved'";
                $stmt = $conn->prepare($query);
                $stmt->bind_param('is', $client_id,$send_id_value);
                $stmt->execute();
                $result = $stmt->get_result();
               
                if ($result->num_rows > 0) {
                    
                     $row = $result->fetch_assoc();
                     
                     $apistatuss   = $row['api_status'];
                     $adminStatus = $row['adminStatus'];
                     $status      = $row['status'];
                     $stype       = $row['type'];
                     $promo_cost  = $row['promo_per_msg'];
                     $trans_cost  = $row['trans_per_msg'];
                     
                     if($apistatuss === 1){
                         
                        $query = "SELECT * FROM `clients` WHERE `c_id` = ? AND `status`= 1 AND `verification_status`=1";
                        $stmt = $conn->prepare($query);
                        $stmt->bind_param('i', $client_id);
                        $stmt->execute();
                        $result = $stmt->get_result();
                       
                        if ($result->num_rows > 0) {
                            
                             $row = $result->fetch_assoc();
                             
                             $api_key_client = $row['api_key'];
                             $clientBalance =  $row['current_balance'];
                             
                             if($api_key == $api_key_client){
                                 
                                 if($recipient_contact_no){
                                     
                                         if (preg_match('/[^\d\+]/', $recipient_contact_no)) {
                                             
                                                //Contact Number is Invalid 
                                             
                                                 $response = array (
                                                'status_code' => 203,
                                                'msg_id' => 'no'
                                                  );
                                          }else{
                                            
            
                                                    
                                                    $contactNumLen =  strlen($recipient_contact_no);
                                              
                                                          if($contactNumLen === 11){
                                                              
                                                              $messageN = str_replace(array("\r\n", "\r", "\n"),'\\n', $message);
                                                              $charactorType = mb_detect_encoding($messageN, 'ASCII', true);
                                                              $totalPages =  CharacterTypemessage($charactorType,$messageN);
                                                              $characterCountn = mb_strlen($messageN, 'UTF-8');
                                                              
                                                              if($charactorType ==='ASCII'){
                                                                  $encodingtype = 'ASCII';
                                                              }else{
                                                                  
                                                                  $encodingtype = 'UNICODE';
                                                                  
                                                              }
                                                              
                                                             if($totalPages !=='noUnicodeLimit' || $totalPages !=='maxcount'){
                                                                  
                                                                  if($stype ==='promotional'){
                                                                      $price_per_page = $promo_cost;
                                                                      
                                                                  }else if($stype ==='transactional'){
                                                                      
                                                                       $price_per_page = $trans_cost;
                                                                      
                                                                  }
                                                                  
                                                                   $totalsmsCost = $totalPages * $price_per_page;
                                                                   
                                                                   if($totalsmsCost > $clientBalance ){
                                                                       
                                                                           //Account Balance is Insufficient
                                                                         
                                                                             $response = array (
                                                                            'status_code' => 208,
                                                                            'msg_id' => 'no'
                                                                              );
                                                                       
                                                                       
                                                                   }else{
                                                                       
                                                                                        $gateway_id =  getGatewayid($client_id,$send_id_value);
                                                                                        $bulkid = generateRandomToken(); 
                                                                       
                                                                                        $data = array(
                                                                                            'senderID' => $send_id_value,
                                                                                            'recipient_contact_no' => $recipient_contact_no,
                                                                                            'client_id' => $client_id,
                                                                                            'message'=>$messageN,
                                                                                            'gateway_id'=>$gateway_id,
                                                                                            'secret_key'=>'oZone@2024*API'
                                                                                        );
                                                                                        
                                                                                        // Convert the data array to JSON format
                                                                                        $data_json = json_encode($data);
                                                                                        
                                                                                        // Initialize cURL
                                                                                        $ch = curl_init('https://backendapi.ozonesender.com/backend/route.php');
                                                                                        
                                                                                        // Set the options for the POST request
                                                                                        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                                                                                        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));
                                                                                        curl_setopt($ch, CURLOPT_POST, true);
                                                                                        curl_setopt($ch, CURLOPT_POSTFIELDS, $data_json);
                                                                                        
                                                                                        // Execute the POST request
                                                                                        $response1 = curl_exec($ch);
                                                                                        
                                                                                        // Check for errors
                                                                                        if($response1 === FALSE){
                                                                                            die(curl_error($ch));
                                                                                        }
                                                                                        
                                                                                        
                                                                                      
                                                                                        
                                                                                        // Close the cURL session
                                                                                        curl_close($ch);
                                                                                        
                                                                                        $sms_result_array = json_decode($response1, true);
                                                                                        
                                                                                        if($gateway_id == 1){
                                                                                            
                                                                                            $status_code = $sms_result_array['status_code'];
                                                                                            $msg_id      = $sms_result_array['msg_id'];
                                                                                            
                                                                                            if($status_code == 204){
                                                                                             
                                                                                                $gateway_status = 2;
                                                                                            }else{
                                                                                                
                                                                                                 $gateway_status = 3;
                                                                                            }
                                                                                                                         
                                                                                          
                                                                                            
                                                                                            
                                                                                        }else if($gateway_id == 2){
                                                                                            
                                                                                            $status = $sms_result_array['status'];
                                                                                            $result = $sms_result_array['result'];
                                                                                            $msg_id = $sms_result_array['msg_id'];
                                                                                            
                                                                                             if ($status == 'success') {
                                                                                                 $gateway_status = 2;
                                                                                                 
                                                                                             }else{
                                                                                                  $gateway_status = 3;
                                                                                             }
                                                                                            
                                                                                        }else if($gateway_id == 3){
                                                                                            
                                                                                            $sms_ststus = $sms_result_array["status"];
                                                                                            $sms_comment =$sms_result_array["comment"];
                                                                                            $msg_id =$sms_result_array["data"]["campaignId"];
                                                                                            $sms_gateway_cost = $sms_result_array["data"]["campaignCost"];
                                                                                            $sms_Gateway_error= $sms_result_array["data"]["errCode"];
                                                                                            
                                                                                             if ($sms_ststus == 'success') {
                                                                                                 $gateway_status = 2;
                                                                                                 
                                                                                             }else{
                                                                                                  $gateway_status = 3;
                                                                                             }
                                                                                            
                                                                                        }else if($gateway_id == 4){
                                                                                            
                                                                                             $msg_id = $sms_result_array["serverRef"];
                                                                                             $gateway_status = 2;
                                                                                            
                                                                                            
                                                                                        }
                                                                                        
                                                                                        
                                                                                              $type ='apiind';
                                                                                          
                                                                                                $dateind = date("Y-m-d H:i:s");
                                                                                          
                                                                                                $scheduleDateandtimen='no';
                                                                                             
                                                                                               
                                                                                                $sql_log_insert       = "INSERT INTO `logs` (`sender_id`,`message`,`type`,`schedule`,`send_to`,`client_id`,`create_date`,`send_date`,`serverResponse`,`bulkid`,`g_deliveryStatus`,`g_responce_id`,`page_count`,`total_cost`,`c_count`,`c_type`,`rate`) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
                                                                                                $result_log_insert    = $conn->prepare($sql_log_insert);
                                                                                                $result_log_insert->execute([$send_id_value, $messageN, $type,$scheduleDateandtimen,$recipient_contact_no,$client_id,$dateind,$dateind,$response1,$bulkid,$gateway_status,$msg_id,$totalPages,$totalsmsCost,$characterCountn,$encodingtype,$price_per_page]); 
                                                                                                
                                                                                                $last_Id          =  mysqli_insert_id($conn);
                                                                                                
                                                                                                 if ($result_log_insert){
                                                                                                     
                                                                                                        $current_balance =  $clientBalance - $totalsmsCost;
                                                                                                    
                                                                                                        $sql_update_ind  = "UPDATE `clients` SET `current_balance`=? WHERE `c_id` = ? ";
                                                                                                        $res_update_inv  = $conn->prepare($sql_update_ind);
                                                                                                        $res_update_inv->bind_param('si', $current_balance, $client_id);
                                                                                                        $res_update_inv->execute();
                                                                                                        
                                                                                                        if($res_update_inv){
                                                                                                            
                                                                                                           
                                                                                                            $typemessage='apiind';
                                                                                                             $datetim = date("Y-m-d H:i:s");
                                                                                                            $sql_account_insert       = "INSERT INTO `account_history` (`current_balance`,`cost`,`new_balance`,`datetime`,`log`,`type`,`pages`,`c_type`,`byID`,`whose`) VALUES (?,?,?,?,?,?,?,?,?,?)";
                                                                                                            $result_account_insert    = $conn->prepare($sql_account_insert);
                                                                                                            $result_account_insert->execute([$clientBalance, $totalsmsCost, $current_balance,$datetim,$last_Id,$typemessage,$totalPages,$encodingtype,$client_id,$client_id]); 
                                                                                                            
                                                                                                          
                                                                                                        
                                                                                                               $response = array (
                                                                                                        'status_code' => 204,
                                                                                                        'msg_id' => $last_Id
                                                                                                          );
                                                                                                            
                                                                                                            
                                                                                                        }
                                                                            
                                                                                                        $log = 'API individual  sms send by Client id : '.$client_id.' to '.$recipient_contact_no.' using '.$send_id_value.' with a '.$totalsmsCost.'LKR cost'.' (Sms  Log Id - '.$last_Id.' )';
                                                                                                        $module_inv     = "SMS Manager";
                                                                                                        insertLog($client_id, $log, $module_inv);
                                                                                                     
                                                                                                      //Successfuly Sent the Message
                                                                                     
                                                                                                      
                                                                                                     
                                                                                                     
                                                                                                     
                                                                                                 }else{
                                                                                                     
                                                                                                        //Sending the Messsage is Unsuccessfull
                                                                                     
                                                                                                         $response = array (
                                                                                                        'status_code' => 209,
                                                                                                        'msg_id' => 'no'
                                                                                                          );
                                                                                                 }
                                                                       
                                                                   
                                                                  
              
                                                                   }
                                                                  
                                                                  
                                                                  
                                                              }else{
                                                                  
                                                                //Sending the Messsage is Unsuccessfull
                                                             
                                                                 $response = array (
                                                                'status_code' => 209,
                                                                'msg_id' => 'no'
                                                                  );
                                                                  
                                                              }
                               
                                                          }else{
                                                              
                                                            //Length of Contact is Invalid 
                                                         
                                                             $response = array (
                                                            'status_code' => 205,
                                                            'msg_id' => 'no'
                                                              );
                                                          }
                                                    
                                                
                        
                                            
                                        }
                  
                                     
                                 }else{
                                     
                                    // No Contact Number
                                 
                                     $response = array (
                                    'status_code' => 207,
                                    'msg_id' => 'no'
                                      );
                                     
                                 }
                  
                                 
                             }else{
                                 
                                 // invalid api key
                                 
                                     $response = array (
                                    'status_code' => 202,
                                    'msg_id' => 'no'
                                      );
                                 
                             }
                             
                        }else{
                            
                        //client is suspended
                            
                        $response = array (
                        'status_code' => 210,
                        'msg_id' => 'no'
                          );
                         
                        }
                        
                        
                         
                     }else{
                         
                         //API Status is Inactive
                         
                        $response = array (
                        'status_code' => 201,
                        'msg_id' => 'no'
                          );
                         
            
                     }
                     
                }else{
                    
                    //no sender id or Inactive sender id or not Approved senderID
                    
                    $response = array (
                        'status_code' => 211,
                        'msg_id' => 'no'
                          );
                    
               
                    
                }
            
            
        }else{
            
        //client api status inactive
        
        $response = array (
            'status_code' => 201,
            'msg_id' => 'no'
              );
            
        }
        
        
        
        
    }else{
     $response = array (
            'status_code' => 0,
            'msg_id' => 'nor'
              );
    }

 }else{
        
        $response = array (
            'status_code' => 214,
            'msg_id' => 'no'
              );
        
    }


 echo json_encode($response);


?>